VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSolidEdge"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
'bentigt
'   Klassenmodule
'        clsFileString           \\solidserv\daten\admin\programme\src\klassensammlung\filestring\
'   Verweise
'       SolidEdge Framework
'       SolidEdge Part
'       SolidEdge Assembly
'       ...

Option Explicit

Private seApp As SolidEdgeFramework.Application
Private bSEerstellt As Boolean
Private bSEschliessen As Boolean
Private bSEvorhanden As Boolean
Private lWinState As Long
Private objFS As clsFileString
Private sError As String
'
Public Property Get getError() As String
'
    getError = sError
'
End Property

Public Function speichereSolidEdgeDokument(ByVal DateiName As String) As Boolean
    Dim objSeApp As SolidEdgeFramework.Application
    Dim i As Long
    Dim LangerUNCDateiName As String
    Dim bErgebnis As Boolean
    bErgebnis = False
    LangerUNCDateiName = objFS.convertNachUNC(DateiName)                'in unc Pfad konvertieren
    On Error GoTo err_handler:
    sError = vbNullString
    '
    Set objSeApp = liefereSolidEdgeApplication                          'Referenz auf SE holen
    For i = objSeApp.Documents.Count To 1 Step -1                       'alle offenenen Se Dokumente abklappern
        If objFS.convertNachUNC(objSeApp.Documents(i).FullName) = LangerUNCDateiName Then
            Call objSeApp.Documents(i).Save                             'speichern
            bErgebnis = True
        End If
    Next i
cleanup:
    Set objSeApp = Nothing
    speichereSolidEdgeDokument = bErgebnis
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

Public Function schlieseSolidEdgeDokument(ByVal DateiName As String) As Boolean
    Dim objSeApp As SolidEdgeFramework.Application
    Dim i As Long
    Dim LangerUNCDateiName As String
    Dim bErgebnis As Boolean
    bErgebnis = False
    LangerUNCDateiName = objFS.convertNachUNC(DateiName)                'in unc Pfad konvertieren
    sError = vbNullString
    On Error GoTo cleanup:
    '
    Set objSeApp = liefereSolidEdgeApplication                          'Referenz auf SE holen
    If objSeApp Is Nothing Then
        GoTo cleanup
    End If
    For i = objSeApp.Documents.Count To 1 Step -1                       'alle offenenen Se Dokumente abklappern
        If objFS.convertNachUNC(objSeApp.Documents(i).FullName) = LangerUNCDateiName Then
            Call objSeApp.Documents(i).Close(False)                     'schliesen
            bErgebnis = True
        End If
    Next i
cleanup:
    Set objSeApp = Nothing
    schlieseSolidEdgeDokument = bErgebnis
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function
'
Public Function liefereSolidEdgeDraftDokument(ByVal DateiName As String) As SolidEdgeDraft.DraftDocument
'
Dim objSeApp As SolidEdgeFramework.Application
Dim i As Long
Dim objFS As clsFileString
Dim LangerUNCDateiName As String
'
    Set objFS = New clsFileString
    LangerUNCDateiName = objFS.convertNachUNC(DateiName)                'in unc Pfad konvertieren
    Set liefereSolidEdgeDraftDokument = Nothing
    sError = vbNullString
    On Error GoTo cleanup:
    '
    Set objSeApp = liefereSolidEdgeApplication                          'Referenz auf SE holen
    If objSeApp Is Nothing Then
        GoTo cleanup
    End If
    For i = 1 To objSeApp.Documents.Count                               'alle offenenen Se Dokumente abklappern
        If (objFS.convertNachUNC(objSeApp.Documents(i).FullName) = LangerUNCDateiName) And _
                    (objSeApp.Documents(i).Type = igDraftDocument) Then
                                                                        'Datei schon offen
            Set liefereSolidEdgeDraftDokument = objSeApp.Documents(i)    'zurck geben
            Set objSeApp = Nothing                                      'Objekt freigeben
            Exit Function                                               'Funktion beenden
        End If
    Next i
                                                                        'in den offenenen Doks nichts gefunden ==> ffnen
    Call objSeApp.Documents.Open(LangerUNCDateiName)
    If objSeApp.ActiveDocumentType = igDraftDocument Then
        Set liefereSolidEdgeDraftDokument = objSeApp.ActiveDocument
    Else
        Call schlieseSolidEdgeDokument(LangerUNCDateiName)
        Set liefereSolidEdgeDraftDokument = Nothing
    End If
cleanup:
    Set objSeApp = Nothing
    Set objFS = Nothing
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

Public Function liefereSolidEdgeAssemblyDokument(ByVal DateiName As String) As SolidEdgeAssembly.AssemblyDocument
    Dim objSeApp As SolidEdgeFramework.Application
    Dim i As Long
    Dim LangerUNCDateiName As String
    
    sError = vbNullString
    LangerUNCDateiName = objFS.convertNachUNC(DateiName)                'in unc Pfad konvertieren
    Set liefereSolidEdgeAssemblyDokument = Nothing
    '
    On Error GoTo cleanup
    Set objSeApp = liefereSolidEdgeApplication                          'Referenz auf SE holen
    If objSeApp Is Nothing Then
        GoTo cleanup
    End If
    For i = 1 To objSeApp.Documents.Count                               'alle offenenen Se Dokumente abklappern
        If (objFS.convertNachUNC(objSeApp.Documents(i).FullName) = LangerUNCDateiName) And _
                    (objSeApp.Documents(i).Type = igAssemblyDocument) Then
                                                                        'Datei schon offen
            Set liefereSolidEdgeAssemblyDokument = objSeApp.Documents(i)    'zurck geben
            Set objSeApp = Nothing                                      'Objekt freigeben
            Exit Function                                               'Funktion beenden
        End If
    Next i
                                                                        'in den offenenen Doks nichts gefunden ==> ffnen
    Call objSeApp.Documents.Open(LangerUNCDateiName)
    If objSeApp.ActiveDocumentType = igAssemblyDocument Then
        Set liefereSolidEdgeAssemblyDokument = objSeApp.ActiveDocument
    Else
        Set liefereSolidEdgeAssemblyDokument = Nothing
    End If
'
cleanup:
    Set objSeApp = Nothing
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

Public Function liefereSolidEdgePartDokument(ByVal DateiName As String) As SolidEdgePart.PartDocument
    Dim objSeApp As SolidEdgeFramework.Application
    Dim i As Long
    Dim LangerUNCDateiName As String
    
    LangerUNCDateiName = objFS.convertNachUNC(DateiName)                'in unc Pfad konvertieren
    Set liefereSolidEdgePartDokument = Nothing
    sError = vbNullString
    On Error GoTo cleanup:
    '
    Set objSeApp = liefereSolidEdgeApplication                          'Referenz auf SE holen
    If objSeApp Is Nothing Then
        GoTo cleanup
    End If
    For i = 1 To objSeApp.Documents.Count                               'alle offenenen Se Dokumente abklappern
        If (objFS.convertNachUNC(objSeApp.Documents(i).FullName) = LangerUNCDateiName) And _
                    (objSeApp.Documents(i).Type = igPartDocument) Then
                                                                        'Datei schon offen
            Set liefereSolidEdgePartDokument = objSeApp.Documents(i)    'zurck geben
            Set objSeApp = Nothing                                      'Objekt freigeben
            Exit Function                                               'Funktion beenden
        End If
    Next i
                                                                        'in den offenenen Doks nichts gefunden ==> ffnen
    Call objSeApp.Documents.Open(LangerUNCDateiName)
    If objSeApp.ActiveDocumentType = igPartDocument Then
        Set liefereSolidEdgePartDokument = objSeApp.Documents.Open(LangerUNCDateiName)
    Else
        Set liefereSolidEdgePartDokument = Nothing
    End If
cleanup:
    Set objSeApp = Nothing
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

Public Sub schliesseSolidEdgeApplication()
    Call liefereSolidEdgeApplication.Quit
    bSEvorhanden = False
    bSEerstellt = False
End Sub

Public Function liefereSolidEdgeApplication() As SolidEdgeFramework.Application
'
    sError = vbNullString
    If Not bSEvorhanden Then
        Set seApp = Nothing
        Err.Clear
        On Error Resume Next
            Set seApp = GetObject(, "SolidEdge.Application")
            If Err.Number <> 0 Then                                                 'Se noch nicht geladen
                Err.Clear
                Set seApp = CreateObject("SolidEdge.Application")
                If Err.Number <> 0 Then
                    Set seApp = Nothing
                    bSEvorhanden = False
                    bSEerstellt = False
                    sError = Err.Number & " / " & Err.Description
                    GoTo cleanup:
                Else
                    bSEvorhanden = True
                    bSEerstellt = True
                End If
            Else
                bSEvorhanden = True
                bSEerstellt = False
                seApp.Activate
                lWinState = IIf(seApp.WindowState = vbNormal, vbMaximized, seApp.WindowState)
            End If
            lSeVersion = CLng(Left(seApp.Version, InStr(1, seApp.Version, ".", vbTextCompare) - 1))
        On Error GoTo 0
    End If
    '
cleanup:
    Set liefereSolidEdgeApplication = seApp
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

' ffnet ein SE - Dokument
' RETURN: True bei Erfolg, False bei Fehler
Public Function oeffneDokument(ByVal sDokument As String) As Boolean
    Dim seApp As SolidEdgeFramework.Application
    oeffneDokument = False
    sError = vbNullString
    On Error GoTo cleanup:
    '
    Set seApp = Me.liefereSolidEdgeApplication
    If seApp Is Nothing Then
        GoTo cleanup
    End If
        seApp.DisplayAlerts = False
        seApp.Visible = False
        seApp.Documents.Open sDokument
        oeffneDokument = True
cleanup:
    Set seApp = Nothing
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

' ermittlet den Dokumenttyp des aktiven Dokumentes
' RETURN: der Dokumenttyp
Public Function ermittleDokumentTyp() As String
'
Dim sErgebnis As String
Dim seApp As SolidEdgeFramework.Application
'
    On Error GoTo cleanup:
    sError = vbNullString
    ermittleDokumentTyp = ""
    '
    Set seApp = Me.liefereSolidEdgeApplication
    If seApp Is Nothing Then
        GoTo cleanup
    End If
    If seApp.Documents.Count > 0 Then
        Select Case seApp.ActiveDocumentType
            Case igAssemblyDocument
                ermittleDokumentTyp = "ASM"
            Case igPartDocument
                ermittleDokumentTyp = "PAR"
            Case igWeldmentDocument
                ermittleDokumentTyp = "PSM"
            Case igSheetMetalDocument
                ermittleDokumentTyp = "SES"
            Case igDraftDocument
                ermittleDokumentTyp = "SED"
            Case Else
                ermittleDokumentTyp = ""
        End Select
    End If
cleanup:
    Set seApp = Nothing
    '
    Exit Function
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

' schliet das angegebene Dokument
' RETURN: 0 bei Erfolg always
Public Function schliesseDokument(ByVal sDokument As String) As Long
Dim seApp As SolidEdgeFramework.Application
    schliesseDokument = 0
    sError = vbNullString
    On Error GoTo cleanup:
    '
    Set seApp = Me.liefereSolidEdgeApplication
    seApp.ActiveDocument.Close False
cleanup:
    Set seApp = Nothing
    Exit Function
    '
err_handler:
    sError = Err.Number & " / " & Err.Description
    Resume cleanup
    
End Function

Private Sub Class_Initialize()
    bSEerstellt = False
    bSEschliessen = True
    bSEvorhanden = False
    Set objFS = New clsFileString
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    Set objFS = Nothing
    If bSEvorhanden Then
        seApp.DisplayAlerts = True
        seApp.Interactive = True
        If bSEerstellt Then
            seApp.WindowState = 2        ' window Max
            If bSEschliessen Then
                seApp.Quit
            Else
                seApp.Visible = True
            End If
        Else
            seApp.WindowState = lWinState
        End If
    End If
    Set seApp = Nothing
End Sub

Public Function alteDateiVersion(ByVal LastSavedVersion As String, Optional ByVal VersionsGenauigkeit As Long = 1) As Boolean
    Dim sDateiVersion() As String
    Dim sAppVersion() As String
    Dim i As Long
    If LastSavedVersion = "" Then
        alteDateiVersion = True
        Exit Function
    End If
    sDateiVersion = Split(LastSavedVersion, ".")
    sAppVersion = Split(liefereSolidEdgeApplication.Version, ".")
    For i = 1 To VersionsGenauigkeit
        If CLng(sDateiVersion(LBound(sDateiVersion) + i - 1)) < CLng(sAppVersion(LBound(sAppVersion) + i - 1)) Then
            alteDateiVersion = True
            Exit Function
        End If
    Next i
    alteDateiVersion = False
End Function
